package kz.arta.ext.sap;

import kz.arta.ext.sap.util.ImportBean;

import javax.ejb.Singleton;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.atomic.AtomicInteger;

public class State {

    public volatile AtomicInteger imported = new AtomicInteger();
    public volatile AtomicInteger count = new AtomicInteger();
    public int totalAmount;
    public volatile List<String> errors = new ArrayList<>();

    public State(){}

    public State(int totalAmount){
        this.totalAmount = totalAmount;
        imported.set(0);
        count.set(0);
        errors = new ArrayList<>();
    }

    public String toJSON(){
        String json = "";
        json += "{";

        json += "\"total\": " + totalAmount + ", ";
        json += "\"imported\": " + imported + ", ";
        json += "\"count\": " + count + ", ";

        json += "\"errors\": [";
        for(String str : errors){
            json += "\"" + unescapeJSONSpecials(str) + "\",";
        }

        if(errors.size() > 0) {
            json = json.substring(0, json.length() - 1) + "]";
        } else {
            json += "]";
        }

        json += "}";
        return json;
    }


    private static String unescapeJSONSpecials(String value){
        value = value.replaceAll("\"", "\\\\\"");
        value = value.replaceAll("\'", "\\\\\'");
        value = value.replaceAll("\b", "\\\\\b");
        value = value.replaceAll("\f", "\\\\\f");
        value = value.replaceAll("\n", "\\\\\n");
        value = value.replaceAll("\r", "\\\\\r");
        value = value.replaceAll("\t", "\\\\\t");
        return value;
    }
}
